root ?= $(shell pwd)

csrc = $(wildcard $(root)/src/*.c) \
	   $(wildcard $(root)/libs/vmath/*.c) \
	   $(wildcard $(root)/libs/anim/*.c) \
	   $(wildcard $(root)/libs/imago/*.c) \
	   $(wildcard $(root)/libs/drawtext/*.c) \
	   $(wildcard $(root)/libs/libpng/*.c) \
	   $(wildcard $(root)/libs/zlib/*.c) \
	   $(wildcard $(root)/libs/libjpeg/*.c) \
	   $(wildcard $(root)/libs/ogg/*.c) \
	   $(wildcard $(root)/libs/vorbis/*.c) \
	   $(wildcard $(root)/libs/psys/*.c)

ccsrc = $(wildcard $(root)/src/*.cc) \
		$(wildcard $(root)/src/audio/*.cc) \
		$(wildcard $(root)/libs/vmath/*.cc)

obj = $(ccsrc:.cc=.o) $(csrc:.c=.o)
dep = $(obj:.o=.d)
bin = xmas_inferno
title = Xmas Inferno

# compiler options
opt = -O0
dbg = -g
warn = -pedantic -Wall
incpaths = -I$(root)/src -I$(root)/libs -I$(root)/libs/imago \
		   -I$(root)/libs/drawtext -I$(root)/libs/vorbis -I$(root)/libs/psys \
		   -I$(root)/libs/libjpeg -I$(root)/libs/libpng -I$(root)/libs/zlib \
		   -I/usr/local/include

CFLAGS = $(warn) $(opt) $(dbg) $(incpaths)
CXXFLAGS = $(warn) $(opt) $(dbg) $(incpaths)

# linker options
LDFLAGS = -L/usr/local/lib -lpthread -lm -ldl
