attribute vec4 a_vertex;
attribute vec4 a_pos;
attribute vec4 a_color;

uniform mat4 st_view_matrix, st_proj_matrix;

varying vec3 wpos;
varying vec4 color;
varying vec2 texcoord;

void main()
{
	float size = a_pos.w;

	mat4 world = mat4(1.0, 0.0, 0.0, 0.0,
			0.0, 1.0, 0.0, 0.0,
			0.0, 0.0, 1.0, 0.0,
			a_pos.x, a_pos.y, a_pos.z, 1.0);

	wpos = (world * a_vertex).xyz;

	mat4 mvmat = st_view_matrix * world;
	mvmat[0][0] = mvmat[1][1] = mvmat[2][2] = size;
	mvmat[0][1] = mvmat[0][2] = mvmat[1][2] = 0.0;
	mvmat[1][0] = mvmat[2][0] = mvmat[2][1] = 0.0;

	gl_Position = st_proj_matrix * mvmat * a_vertex;

	color = a_color;
	texcoord = a_vertex.xy * 0.5 + 0.5;
}
