varying vec3 vpos, norm;
varying vec2 texcoord;

void main()
{
	vec3 n = normalize(norm);
	vec3 l = normalize(vec3(-0.5, 0.5, 2));

	float ndotl = max(dot(n, l), 0.0);

	vec3 color = vec3(0.8, 0.8, 0.8) * ndotl;

	float hpat = smoothstep(0.49, 0.5, mod(texcoord.x * 8.0, 1.0));
	float vpat = smoothstep(0.49, 0.5, mod(texcoord.y * 8.0, 1.0));

	float pattern = 0.0;
	if((hpat > 0.5 && vpat > 0.5) || (hpat < 0.5 && vpat < 0.5)) {
		pattern = 1.0;
	} else {
		pattern = 0.0;
	}

	vec3 tex = vec3(pattern * 0.5 + 0.5);


	gl_FragColor.rgb = color * tex;
	gl_FragColor.a = 1.0;
}
