attribute vec4 attr_vertex;
attribute vec3 attr_normal;
attribute vec2 attr_texcoord;

uniform mat4 st_world_matrix, st_view_matrix, st_proj_matrix;
uniform mat3 st_world_matrix3, st_view_matrix3;
uniform mat4 st_tex_matrix;
uniform vec3 st_light_pos;

varying vec3 wpos, vpos, norm, ldir;
varying vec2 texcoord;

void main()
{
	mat4 worldview_matrix = st_view_matrix * st_world_matrix;
	mat4 mvp_matrix = st_proj_matrix * worldview_matrix;

	gl_Position = mvp_matrix * attr_vertex;

	wpos = (st_world_matrix * attr_vertex).xyz;
	vpos = (worldview_matrix * attr_vertex).xyz;
	norm = st_view_matrix3 * st_world_matrix3 * attr_normal;
	texcoord = (st_tex_matrix * vec4(attr_texcoord, 1.0, 1.0)).xy;

	ldir = (st_view_matrix * vec4(st_light_pos, 1.0)).xyz - vpos;
}
