uniform sampler2D st_tex0;
uniform vec3 st_mtl_diffuse, st_light_color;
uniform float st_mtl_alpha;

varying vec3 vpos, norm, ldir;
varying vec2 texcoord;

void main()
{
	vec3 n = normalize(norm);
	vec3 l = normalize(vec3(0.0, 0.0, 1.0));

	float ndotl = max(dot(n, l), 0.0);

	vec3 color = st_mtl_diffuse * st_light_color * ndotl;

	vec4 tex = texture2D(st_tex0, texcoord);

	gl_FragColor.rgb = color * tex.rgb;
	gl_FragColor.a = st_mtl_alpha * tex.a;
}
