uniform sampler2D st_tex0, st_tex1;
uniform vec3 st_mtl_diffuse, st_light_color;
uniform float st_mtl_alpha;
uniform vec2 fire_interval;

varying vec2 texcoord;
varying vec4 vcolor;

#define AMBOCC		vcolor.a
#define BPOS		vcolor.r
#define FIRE_START	fire_interval.x
#define FIRE_END	fire_interval.y

void main()
{
	vec4 tex = texture2D(st_tex0, texcoord);

	// get the normalized position along the branch and compare with the burn interval
	float burning = step(FIRE_START, BPOS) * (1.0 - step(FIRE_END, BPOS));

	float alpha = st_mtl_alpha * tex.a * (1.0 - burning);
	if(alpha < 0.2) discard;

	vec3 color = st_mtl_diffuse * st_light_color * AMBOCC;

	gl_FragColor.rgb = color * tex.rgb;
	gl_FragColor.a = 1.0;
}
