attribute vec4 attr_vertex;
attribute vec2 attr_texcoord;
attribute vec4 attr_color;

uniform mat4 st_world_matrix, st_view_matrix, st_proj_matrix;
uniform mat4 st_tex_matrix;

varying vec2 texcoord;
varying vec4 vcolor;

void main()
{
	mat4 mvp_matrix = st_proj_matrix * st_view_matrix * st_world_matrix;
	gl_Position = mvp_matrix * attr_vertex;

	texcoord = (st_tex_matrix * vec4(attr_texcoord, 1.0, 1.0)).xy;
	vcolor = attr_color;
}
