uniform sampler2D tex;
//uniform vec3 st_ambient;

#define HALF_PI	1.5707963268

//varying vec3 wpos;
varying vec2 texcoord;
varying vec4 color;

void main()
{
	// XXX spotlight sync with ground.p.glsl
	/*float spot_rad = length(wpos.xz);
	float spot = 1.0 - smoothstep(0.4, 1.2, spot_rad / 4.0);*/

	vec2 p = texcoord * 2.0 - 1.0;
	float rad = min(length(p), 100.0);
	float ca = cos(rad * HALF_PI);

	if(ca < 0.1) discard;

	const vec3 c0 = vec3(0.711, 0.907, 0.912) * 0.5;
	const vec3 c1 = vec3(1.0, 1.0, 1.0);

	vec4 texel = texture2D(tex, texcoord * 0.1 + vec2(0.25, 0.25));
	vec3 col = pow(texel.rgb, vec3(0.15, 0.15, 0.15));// * (ca + 0.2) * color.rgb;

	col *= mix(c0, c1, ca);

	gl_FragColor.rgb = /*st_ambient + */col;// * spot;
	gl_FragColor.a = color.a * texel.a;
}
