#ifndef INPUT_H_
#define INPUT_H_

/// special (non-alpharithmetic/ascii) key enums
enum {
	KEY_PAUSE		= 0xff13,	// XK_Pause
	KEY_SCRLOCK		= 0xff14,	// XK_Scroll_Lock
	KEY_PRINTSCR	= 0xff15,	// XK_Sys_Req

	KEY_HOME		= 0xff50,	// XK_Home
	KEY_LEFT		= 0xff51,	// XK_Left
	KEY_UP			= 0xff52,	// XK_Up
	KEY_RIGHT		= 0xff53,	// XK_Right
	KEY_DOWN		= 0xff54,	// XK_Down
	KEY_PGUP		= 0xff55,	// XK_Page_Up
	KEY_PGDOWN		= 0xff56,	// XK_Page_Down
	KEY_END			= 0xff57,	// XK_End

	KEY_INSERT		= 0xff63,	// XK_Insert

	KEY_F1			= 0xffbe,	// XK_F1
	KEY_F2			= 0xffbf,	// XK_F2
	KEY_F3			= 0xffc0,	// XK_F3
	KEY_F4			= 0xffc1,	// XK_F4
	KEY_F5			= 0xffc2,	// XK_F5
	KEY_F6			= 0xffc3,	// XK_F6
	KEY_F7			= 0xffc4,	// XK_F7
	KEY_F8			= 0xffc5,	// XK_F8
	KEY_F9			= 0xffc6,	// XK_F9
	KEY_F10			= 0xffc7,	// XK_F10
	KEY_F11			= 0xffc8,	// XK_F11
	KEY_F12			= 0xffc9,	// XK_F12

	KEY_LSHIFT		= 0xffe1,	// XK_Shift_L
	KEY_RSHIFT		= 0xffe2,	// XK_Shift_R
	KEY_LCTRL		= 0xffe3,	// XK_Control_L
	KEY_RCTRL		= 0xffe4,	// XK_Control_R
	KEY_CAPSLOCK	= 0xffe5,	// XK_Caps_Lock
	KEY_SHIFTLOCK	= 0xffe6,	// XK_Shift_Lock
	KEY_LMETA		= 0xffe7,	// XK_Meta_L
	KEY_RMETA		= 0xffe8,	// XK_Meta_R
	KEY_LALT		= 0xffe9,	// XK_Alt_L
	KEY_RALT		= 0xffea,	// XK_Alt_R

	KEY_DELETE		= 0xffff	// XK_Delete
};

// aliases
enum {
	KEY_ALT = KEY_LALT,
	KEY_CTRL = KEY_LCTRL,
	KEY_SHIFT = KEY_LSHIFT
};

void set_key_state(int key, bool state);
bool get_key_state(int key);


void set_mouse_state(int x, int y, int bn = -1, bool state = false);

bool mouse_button(int bn = 0);

/// are we in the middle of a mouse-drag ? (pressed and moved)
/// only valid between a mouse press and mouse release event
bool mouse_dragging(int bn = 0);

bool mouse_drag_origin(int bn, int *xorig, int *yorig);

#endif	// INPUT_H_
