#import <UIKit/UIKit.h>
#import <QuartzCore/QuartzCore.h>

#import <OpenGLES/ES2/gl.h>
#import <OpenGLES/ES2/glext.h>

@interface GLView : UIView
{
@private
	int xsz, ysz;
	EAGLContext *context;

	unsigned int fbo, rbuf_color, rbuf_depth;

	BOOL animating;
	BOOL display_link_supported;
	NSInteger anim_frame_interval;
	// Use of the CADisplayLink class is the preferred method for controlling your animation timing.
	// CADisplayLink will link to the main display and fire every vsync when added to a given run-loop.
	// The NSTimer class is used only as fallback when running on a pre 3.1 device where CADisplayLink
	// isn't available.
	id display_link;
	NSTimer *anim_timer;
}

@property (readonly, nonatomic, getter=isAnimating) BOOL animating;
@property (nonatomic) NSInteger anim_frame_interval;

- (void)startAnimation;
- (void)stopAnimation;
- (void)drawView: (id)sender;
- (void)swap_buffers;

@end
