#ifndef MATERIAL_H_
#define MATERIAL_H_

#include "vmath/vmath.h"
#include "texture.h"

enum {
	TEX_DIFFUSE,
	TEX_SPECULAR,
	TEX_NORMAL,
	TEX_MISC,

	MAX_MTL_TEXTURES
};

class Material {
public:
	Vector3 diffuse, specular;
	float alpha;
	float shininess;

	Texture *tex[MAX_MTL_TEXTURES];
	Matrix4x4 tex_xform;

	Material();

	void setup(bool use_textures = true) const;
};

#endif	// MATERIAL_H_
