#ifndef PSYS_FIRE_H_
#define PSYS_FIRE_H_

#include <vector>
#include "psyspp.h"

class PineTree;
class PineTreeBranch;

// a particle system for the branch fires which overrides
// the spawning function to spawn on the flame intervals of the
// burning branches
class FireParticleSystem : public ParticleSystem {
private:
	struct SpawnCDFEntry { float prob; PineTreeBranch* branch; };

	PineTree *tree;
	std::vector<SpawnCDFEntry> spawn_cdf;
	float orig_spawn_rate;

public:
	FireParticleSystem();
	void set_parent_tree(PineTree *tree);
	virtual bool spawn(struct psys_particle *p) const;
	virtual void update(long tm);
};

#endif // PSYS_FIRE_H_
