#ifndef RNG_H_
#define RNG_H_

#include <stdint.h>

struct RandGenState;

class RandGen {
private:
	RandGenState *state;

	RandGen(const RandGen&);
	RandGen &operator =(const RandGen&);

public:
	RandGen();
	~RandGen();

	void seed(uint32_t s);

	uint32_t generate();
	float generate_float();
};

void rng_srand(uint32_t s);
uint32_t rng_rand();
float rng_frand();


#endif	// RNG_H_
