#include "scene.h"
#include "opengl.h"

Scene::~Scene()
{
	clear();
}

void Scene::clear()
{
	for(size_t i=0; i<objects.size(); i++) {
		delete objects[i];
	}
	objects.clear();

	for(size_t i=0; i<meshes.size(); i++) {
		delete meshes[i];
	}
	meshes.clear();

	for(size_t i=0; i<curves.size(); i++) {
		delete curves[i];
	}
	curves.clear();
}

bool Scene::load(const char *fname)
{
	return false;
}

bool Scene::save(const char *fname) const
{
	return false;	// TODO
}

void Scene::draw(long msec) const
{
	if(objects.empty()) {
		int num = meshes.size();
		for(int i=0; i<num; i++) {
			meshes[i]->draw();
		}
	} else {
		int num = objects.size();
		for(int i=0; i<num; i++) {
			objects[i]->draw(msec);
		}
	}
}
