#ifndef SCENE_H_
#define SCENE_H_

#include <vector>
#include "object.h"
#include "curve.h"

class Scene {
public:
	std::vector<Object*> objects;
	std::vector<Mesh*> meshes;
	std::vector<Curve*> curves;

	~Scene();
	void clear();

	bool load(const char *fname);
	bool save(const char *fname) const;

	void draw(long msec = 0) const;
};

#endif	// SCENE_H_
