#include "scr_overlay.h"
#include "logger.h"

void OverlayScreen::start()
{
	if(!(prev = previous_screen())) {
		error_log("Failed to start overlay screen: %s. No previous screen found.\n", get_name());
	}
	prev->start();
}

void OverlayScreen::stop()
{
	prev->stop();
}

long OverlayScreen::redisplay_interval() const
{
	return prev->redisplay_interval();
}

void OverlayScreen::update(unsigned long tmsec)
{
	prev->update(tmsec);
}

void OverlayScreen::pre_draw() const
{
	prev->pre_draw();
}

void OverlayScreen::display() const
{
	prev->display();
}

void OverlayScreen::post_draw() const
{
	prev->post_draw();
}

void OverlayScreen::keyboard(int key, bool pressed)
{
	prev->keyboard(key, pressed);
}

void OverlayScreen::motion(int x, int y, bool pressed)
{
	prev->motion(x, y, pressed);
}

void OverlayScreen::button(int bn, bool pressed, int x, int y)
{
	prev->button(bn, pressed, x, y);
}

void OverlayScreen::reshape(int x, int y)
{
	prev->reshape(x, y);
}
