#ifndef SCR_OVERLAY_H_
#define SCR_OVERLAY_H_

#include "screen.h"

// abstract base class for overlay screens
class OverlayScreen : public BaseScreen {
protected:
	BaseScreen *prev;

public:
	virtual void start();
	virtual void stop();

	virtual long redisplay_interval() const;

	virtual void update(unsigned long tmsec);

	virtual void pre_draw() const;
	virtual void display() const;
	virtual void post_draw() const;

	virtual void keyboard(int key, bool pressed);
	virtual void motion(int x, int y, bool pressed);
	virtual void button(int bn, bool pressed, int x, int y);
	virtual void reshape(int x, int y);
};

#endif	// SCR_OVERLAY_H_
