#include "sdrman.h"

ShaderSet vsdrset(GL_VERTEX_SHADER);
ShaderSet psdrset(GL_FRAGMENT_SHADER);

ShaderProg *get_sdrprog(const char *vname, const char *pname)
{
	Shader *vsdr = vname ? vsdrset.get(vname) : 0;
	Shader *psdr = pname ? psdrset.get(pname) : 0;

	if(vname && !vsdr) {
		return 0;
	}
	if(pname && !psdr) {
		return 0;
	}
	if(!vsdr && !psdr) {
		return 0;
	}

	ShaderProg *prog = new ShaderProg;
	if(!prog->create(vsdr, psdr)) {
		delete prog;
		return 0;
	}
	return prog;
}
