#ifndef TEXGEN_H_
#define TEXGEN_H_

#include "image.h"
#include "vmath/vmath.h"

Image *texgen_solid(int xsz, int ysz, const Vector4 &color);
Image *texgen_chess(int xsz, int ysz, int usub, int vsub, const Vector4 &col1, const Vector4 &col2);
Image *texgen_fbm(int xsz, int ysz, float usize, float vsize, int octaves, const Vector4 &col1, const Vector4 &col2);
Image *texgen_fbm_abs(int xsz, int ysz, float usize, float vsize, int octaves, const Vector4 &col1, const Vector4 &col2);

Image *texgen(int xsz, int ysz, float usize, float vsize, Vector4 (*eval)(float, float, void*), void *cls);

#endif	// TEXGEN_H_
